//Class for holding a particle
Boolean points = true;

int ALPHA_VAL = 10;

class Node{

  Particle p;
  color c;
  int hue;
  int brightness; 
  float duration;
  
  float angle;
  float radius;
  
  float dX;
  float dY;
  float dZ;
  
  Node(Particle p, ArrayList<Integer> colors, float d, float destX, float destY, float destZ){
   this.p = p;
   int randInt = floor(random(0,colors.size() - 1));
   hue = (int)((255 / 17.0) * (colors.get(randInt)-1));
 
   angle = random( 0, TWO_PI );
   duration = d;
   //radius of circle maps to days
   radius = duration / 24;
   brightness = 255;
   //brightness = map(0, 255, );
   
   dX = destX;
   dY = destY;
   dZ = destZ;
   
  }
  
  void draw(){

    if(points){
      c = color( hue, 255, 255, 255);
      stroke(c);
      point(p.position().x(), p.position().y(), p.position().z());
    }else {
      
      float newX = p.position().x();
      float newY = p.position().y();
      float newZ = p.position().z();
      
      if(p.position().x() < dX){
       newX = newX + 1; 
      }
      if(p.position().y() < dY){
       newY = newY + 1; 
      }
      if(p.position().z() < dZ){
       newZ = newZ + 1; 
      }
      
      p.position().set(newX, newY, newZ);
     // p.position().set(dX, dY, dZ);
      //ALPHA_VAL = 10;
      c = color( hue, 255, brightness, ALPHA_VAL);
      angle += ROTATION_SPEED;
      float y = radius * cos( angle ) + p.position().y();
      float z = radius * sin( angle ) + p.position().z();
      stroke(c);
      line( p.position().x(), p.position().y(), p.position().z(), p.position().x(), y, z);   
    }
  }
}